package se.umu.cs.edu.soa.directoryservice;

import org.apache.axis2.databinding.types.Id;
import org.apache.axis2.databinding.types.URI;

public class DirectoryClient {
	
	public static void main(String[] args) throws Exception {
	
		String target =	"http://operatingsystem.cs.umu.se:8081/axis2/services/DirectoryService"; 
	
		// create the client stub
		DirectoryServiceStub stub = new DirectoryServiceStub(target); 

		String cmd = args[0]; 
		
		if("store".equals(cmd)) {
			
			EntryType newEntry = new EntryType(); 
			Id id = new Id(); 
			id.setValue(args[1]); 
			newEntry.setId(id);  
			newEntry.setType(ServiceType.Factory.fromValue(args[2])); // ServiceType.ChatLogService);
			URI uri = new URI(args[3]);  		
			newEntry.setUrl(uri);
			newEntry.setDescription(args[4]); 
			
			StoreEntrysRequestType requestType = new StoreEntrysRequestType(); 
			requestType.setEntry(new EntryType[]{newEntry}); 			
			StoreEntrysRequest request = new StoreEntrysRequest();
			request.setStoreEntrysRequest(requestType); 			
			stub.storeEntrys(request); 	
			
		}
		if("retrieve".equals(cmd)) {				
			
			ServiceType serviceTypes[] = new ServiceType[args.length-1];
			for(int i = 0; i < args.length-1; i++) {										
				serviceTypes[i] = ServiceType.Factory.fromValue(args[i+1]);						
			}
			
			RetrieveEntrysRequestType requestType = new RetrieveEntrysRequestType();
			requestType.setType(serviceTypes); 
			
			RetrieveEntrysRequest request = new RetrieveEntrysRequest();
			request.setRetrieveEntrysRequest(requestType); 
			
			RetrieveEntrysResponse response = stub.retrieveEntrys(request); 
			EntryType entries[] = response.getRetrieveEntrysResponse().getEntry(); 
			if(entries != null) {
				System.out.println("Found the following entrys:"); 
				for(EntryType entry : entries) {					
					System.out.println(entry.getId()); 
					System.out.println(entry.getType());
					System.out.println(entry.getUrl());
					System.out.println(entry.getDescription() + "\n");
				}				
			}
			else {
				System.out.println("No entries found for specified ServiceTypes"); 
			}			 			
		}
		if("delete".equals(cmd)) {
						
			Id ids[] = new Id[args.length-1];
			for(int i = 0; i < args.length-1; i++) {
				ids[i] = new Id(args[i+1]);
			}
			
			DeleteEntrysRequestType requestType = new DeleteEntrysRequestType();
			requestType.setId(ids);
			DeleteEntrysRequest request = new DeleteEntrysRequest();
			request.setDeleteEntrysRequest(requestType); 
			
			stub.deleteEntrys(request); 									
			
		}
	}


}
