package se.umu.cs.edu.soa.directoryservice;

import java.io.IOException;

import org.apache.axis2.databinding.types.Id;

public class DirectoryServiceImpl extends DirectoryServiceSkeleton {
	
	

	public StoreEntrysResponse storeEntrys(StoreEntrysRequest request)
	throws FailureFaultException {
				
		EntryType[] entries = request.getStoreEntrysRequest().getEntry(); 

		DirectoryServiceCore core = DirectoryServiceCore.Factory.getInstance();
		try {
			core.storeEntrys(entries);
		} catch(IOException e) {
			throw new FailureFaultException(e.getMessage()); 
		}

		StoreEntrysResponse response = new StoreEntrysResponse(); 
		response.setStoreEntrysResponse(new StoreEntrysResponseType()); 
		return response; 
	}

    
    public RetrieveEntrysResponse retrieveEntrys(RetrieveEntrysRequest request)
    	throws FailureFaultException {
    	
    	
    	ServiceType types[] = request.getRetrieveEntrysRequest().getType(); 
    	String typeStrings[] = new String[types.length]; 
        for(int i = 0; i < types.length; i++) {
        	typeStrings[i] = types[i].localServiceType; 
        }
    	
        DirectoryServiceCore core = DirectoryServiceCore.Factory.getInstance();
        EntryType[] entrys = null; 
        try { 
        	entrys = core.retrieveEntrys(typeStrings);
        } catch (IOException e) {
        	throw new FailureFaultException(e.getMessage()); 
        }

    	RetrieveEntrysResponse response = new RetrieveEntrysResponse();
    	RetrieveEntrysResponseType responseType = new RetrieveEntrysResponseType(); 
    	responseType.setEntry(entrys);
    	response.setRetrieveEntrysResponse(responseType); 
    	
    	return response; 
    	 
    }


    public DeleteEntrysResponse deleteEntrys(DeleteEntrysRequest request)
    throws FailureFaultException {

    	Id[] ids = request.getDeleteEntrysRequest().localId; 
    	String idStrings[] = new String[ids.length]; 
    	for(int i = 0; i < ids.length; i++) {
    		idStrings[i] = ids[i].toString(); 
    	}

    	DirectoryServiceCore core = DirectoryServiceCore.Factory.getInstance();
    	try { 
    		core.deleteEntrys(idStrings);
    	} catch (IOException e) {
    		throw new FailureFaultException(e.getMessage()); 
    	}

    	DeleteEntrysResponse response = new DeleteEntrysResponse();       	
    	response.setDeleteEntrysResponse(new DeleteEntrysResponseType()); 
    	return response; 
    }


}
